<?php
// +-----------------------------------------------------------------------+
// | PhpWebGallery - a PHP based picture gallery                           |
// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
// +-----------------------------------------------------------------------+
// | branch        : BSF (Best So Far)
// | file          : $RCSfile$
// | last update   : $Date: 2007-03-16 07:30:07 +0100 (ven, 16 mar 2007) $
// | last modifier : $Author: rub $
// | revision      : $Revision: 1912 $
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

// +-----------------------------------------------------------------------+
// | No include due to call by admin page=plugin                           |
// +-----------------------------------------------------------------------+
check_status(ACCESS_ADMINISTRATOR);
if (isset($_POST['by_line'])) { $default = $_POST; }
else {
  $default = array(
    'by_line'    => 7,  
    'by_column'  => 5, 
    'min_ratio'  => 1.2, 
    'max_ratio'  => 1.5,
    'thb_height' => 96,
    'partner'    => substr(MD5('Wall'.rand()),0,6).'Wall',
    'target_cat' => 0, 
    'refresh'    => 7, 
    'large'      => l10n('Yes'),
    'def_title'  => l10n('wall_'),
    'def_alt'    => l10n('wall_pwg'),
    'Real_title' => substr($conf['gallery_title'],0,10).' ...',
    'update_result' => l10n('wall_on_going'),
  );
}
if (isset($_GET['construction'])) { set_Wall_parms($default); }  
if (isset($_GET['generation'])) { verify_Wall_parms($default); }  

function generate_Wall_parms($base)
{
  global $conf;
  $limit = (int)($base['by_line']*$base['by_column']*15/10);
  $partner = $base['partner'];
  
  $base['Real_title'] = str_replace('\\', '', $base['Real_title']);
  $base['def_title'] = str_replace('\\', '', $base['def_title']);
  $base['def_alt'] = str_replace('\\', '', $base['def_alt']);
  if ($conf['allow_web_services']) {
    $query = 'INSERT INTO ' . WEB_SERVICES_ACCESS_TABLE . ' 
    (`name`, `start`, `end`, `request`, `limit`, `comment`)
    VALUES (  
      ' . "'$partner'" . ',
      NOW(),
      ADDDATE( NOW(), INTERVAL 730 DAY),
      \'categories.getImages\',
      ' . $limit .',
      \'' . substr($base['Real_title'] . '-' . $base['def_title'] 
      . '-' . $base['def_alt'], 0, 25) . '\');';
    $result = pwg_query($query);
    $base['update_result'] = l10n('wall_defined');
  }
  
  $filename = './plugins/picture_wall/new/wall_conf.inc.php';
  @chmod ($filename, 0755);  ;
  $content = '<' . '?php
$wall[\'columns\'] = ' . $base['by_line'] . ';
$wall[\'lines\'] = ' . $base['by_column'] . ';
$wall[\'partner\'] = \'' . $base['partner'] . '\';
// Several walls on one site => change 
$wall[\'image_ratio_min\'] = ' . $base['min_ratio'] . ';
$wall[\'image_ratio_max\'] = ' . $base['max_ratio'] . ';
$wall[\'thumb_height\'] = ' . $base['thb_height'] . ';
$wall[\'refresh\'] = ' . $base['refresh'] . ';
$wall[\'gallery\'] = \'' . get_absolute_root_url() . '\';
$wall[\'server\'] = \'' . get_absolute_root_url() . '\'
      . \'ws.php?method=pwg.categories.getImages&format=php\'
      . \'&recursive=true&order=random&page=0\'
      . \'&partner=' . $base['partner'] . '\'
      . \'&cat_id=' . $base['target_cat'] . '\'
      . \'&f_min_ratio=\' . $wall[\'image_ratio_min\'] 
      . \'&f_max_ratio=\' . $wall[\'image_ratio_max\']
      . \'&f_with_thumbnail=true&per_page=\';
$wall[\'default_title\'] = \'' . $base['def_title'] . '\';
$wall[\'default_alt\'] = \'' . $base['def_alt'] . '\';
$wall[\'title\'] = \'' . $base['Real_title'] . '\';
$wall[\'large\'] = \'' . (($base['large'] == l10n('Yes')) ? 'Yes' : 'No')
      . '\';
?' . '>';
  if (!$handle = @fopen($filename, 'wb')) {
    echo "Impossible d'ouvrir le fichier ($filename)";
  }
  else {
    @fputs($handle, $content, strlen($content));
    @fclose($handle);
  }
  $file = './plugins/picture_wall/wall.php';  
  $newfile = './plugins/picture_wall/new/wall.php';  
  @copy($file, $newfile);
  
  $base['update_result'] .= l10n('wall_built');
  set_Wall_parms($base);

}
function verify_Wall_parms($base)
{
  global $conf;
  
  $base['def_title'] = strip_tags($base['def_title']);
  $base['def_alt'] = strip_tags($base['def_alt']);
  $base['Real_title'] = strip_tags($base['Real_title']);
  $db=$base;
  $db['def_title'] = htmlspecialchars($base['def_title'], ENT_QUOTES);
  $db['def_alt'] = htmlspecialchars($base['def_alt'], ENT_QUOTES);
  $db['Real_title'] = htmlspecialchars($base['Real_title'], ENT_QUOTES);

  if ($base['min_ratio']>$base['max_ratio']) { 
    $base['update_result'] = l10n('wall_minmax');
  }

  // Does the category contains enough pictures 
  $query = '
  SELECT COUNT(DISTINCT(image_id)) as total
    FROM '.IMAGE_CATEGORY_TABLE.'
   WHERE category_id = '.$base['target_cat'].'
  ;';
  list($images_count) = mysql_fetch_array(pwg_query($query));
  $limit = 2;
  if ($images_count < $limit) {
    $base['update_result'] = l10n('wall_catcount');
  }

  // If WS is secured and $partner not set...
  if (isset($base['partner'])) {
    $partner = htmlspecialchars($base['partner'], ENT_QUOTES);
  }
  else { $partner = ''; }
  if ($conf['allow_web_services'] and $partner == '') {
      $base['update_result'] = l10n('wall_mandatory');
  }
  $db['partner'] = $partner;
  
  if ($conf['allow_web_services']) {
    // Does $partner exist already ?
    $query = 'SELECT name FROM ' . WEB_SERVICES_ACCESS_TABLE . ' 
     WHERE name = ' . "'$partner'" . ';';
    $result = pwg_query($query);
    $already = mysql_num_rows($result);
    if ( $already !== 0 ) {
      $base['update_result'] = l10n('wall_already');
    }
  }

  // No logical error => Generate
  if (!isset($base['update_result'])) {
    generate_Wall_parms($db);
  }
  else { set_Wall_parms($base); }
}

function set_Wall_parms($base)
{

  global $conf,$template;
  $base['Real_title'] = str_replace('\\', '', $base['Real_title']);
  $base['def_title'] = str_replace('\\', '', $base['def_title']);
  $base['def_alt'] = str_replace('\\', '', $base['def_alt']);

  $template->set_filenames(array(
    'cement' => PHPWG_PLUGINS_PATH.'picture_wall/cement.tpl')
    );
  $template->assign_vars(
  array(
    'F_DEF_TITLE' => $base['def_title'],
    'F_DEF_ALT' => $base['def_alt'],
    'F_REAL_TITLE' => $base['Real_title'],
    'TAG_INPUT_ENABLED' =>
      ((is_adviser()) ? 'disabled onclick="return false;"' : ''),
    'U_ACTION' => PHPWG_ROOT_PATH
      . 'admin.php?page=plugin&section=picture_wall/cement.php&amp;generation'

    )
  );
  for ($i=4;$i<13;$i++) {
    $template->assign_block_vars(
      'by_line',
      array(
        'VALUE'=> $i,
        'SELECTED' => ($i==$base['by_line']) ? 'selected':'',
        )
    );
    $template->assign_block_vars(
      'by_column',
      array(
        'VALUE'=> $i,
        'SELECTED' => ($i==$base['by_column']) ? 'selected':'',
        )
    );
  }
  for ($i=5;$i<19;$i++) {
    $template->assign_block_vars(
      'min_ratio',
      array(
        'VALUE'=> $i/10,
        'SELECTED' => ($i==($base['min_ratio']*10)) ? 'selected':'',
        )
    );
    $template->assign_block_vars(
      'max_ratio',
      array(
        'VALUE'=> $i/10,
        'SELECTED' => ($i==($base['max_ratio']*10)) ? 'selected':'',
        )
    );
  }
  for ($i=80;$i<181;$i++) {
    $template->assign_block_vars(
      'thb_height',
      array(
        'VALUE'=> $i,
        'SELECTED' => ($i==$base['thb_height']) ? 'selected':'',
        )
    );
  }
  $query = '
SELECT id,name,uppercats,global_rank
  FROM '.CATEGORIES_TABLE.'
  WHERE status = \'public\'
;';

  display_select_cat_wrapper($query,array($base['target_cat']),'target_cat');

  for ($i=5;$i<11;$i++) {
    $template->assign_block_vars(
      'refresh',
      array(
        'VALUE'=> $i,
        'SELECTED' => ($i==$base['refresh']) ? 'selected':'',
        )
    );
  }


  if ($conf['allow_web_services']) {
    $template->assign_block_vars(
      'partner',
      array(
        'F_PARTNER'=> $base['partner'],
        )
    );
  }
  $template->assign_block_vars(
    'update_result',
    array( 
      'UPD_ELEMENT'=> $base['update_result'],
      )
  );

  $template->assign_block_vars(
    'large',
    array(
      'VALUE'=> l10n('Yes'),
      'SELECTED' => (l10n('Yes')==$base['large']) ? 'selected':'',
      )
  );
  $template->assign_block_vars(
    'large',
    array(
      'VALUE'=> l10n('No'),
      'SELECTED' => (l10n('No')==$base['large']) ? 'selected':'',
      )
  );
  
  $template->assign_var_from_handle( 'ADMIN_CONTENT', 'cement');
}

?>
